////////////////////////////////////////////////////
//                                                //
//       test harness for m68882real class        //
//                                                //
////////////////////////////////////////////////////

#include <iostream.h>
#include "real.h"

real a=1.1,b=3.2,c=7.4,d;



main()
{
    real m=a;
    real n;
 
    n=b/real(2.0);
 
    cout << "Should: 1.1 3.2 7.4 0 1.1 1.6" << endl;  
    cout << "    Is: " << a << ' ' << b << ' ' << c << ' '
                       << d << ' ' << m << ' ' << n << endl << endl;  
    cout << "Should: 0 Is: " << int(!a) << endl << endl;
    
    n=-m; 
    m=+c;
    
    c=a+b;

    cout << "Should: -1.1 7.4 4.3" << endl;  
    cout << "    Is: " << n << ' ' << m << ' ' << c << endl << endl;
    
 

    c=m-n;
    d=a*b;
    b=c/n;


    c+=a;
    d-=b;
    n*=c;
    m/=n;

    cout << "Should: -7.727272 9.6 11.247272 -10.56 -0.700757" << endl;  
    cout << "    Is: " << b << ' ' << c << ' ' << d << ' ' << n << ' ' << m << endl << endl;  

   
    cout << "false:" << (a==b) << endl;
    cout << "true:"  << (b!=c) << endl;

    cout << "false:" <<(c< n) << endl;;
    cout << "false:" <<(c<=n) << endl;

    cout << "true:" << (c> n) << endl;
    cout << "true:" << (c>=n) << endl << endl;
    
    cout << "Should be:" << endl;
    cout << "0.479426 0.523599 0.521095" << endl;
    cout << "0.877583 1.047200 1.127630" << endl;
    cout << "0.546302 0.463648 0.462117" << endl;
    cout << "1.648720" << endl;
    cout << "4.812180 2.089910 9" << endl;
    cout << "6 5 5" << endl;
    cout << "-5 -6 -5" << endl;
    cout << "50.75 50.75" << endl;
    cout << "3.25 123 0.456001" << endl << endl;
    
    cout << "Is:" << endl;
      
    cout << sin(real(0.5)) << ' ' << asin(real(0.5)) << ' ' << sinh(real(0.5)) << endl;
    cout << cos(real(0.5)) << ' ' << acos(real(0.5)) << ' ' << cosh(real(0.5)) << endl;
    cout << tan(real(0.5)) << ' ' << atan(real(0.5)) << ' ' << tanh(real(0.5)) << endl;
    cout << exp(real(0.5)) << endl;
    cout << log(real(123.0)) << ' ' << log10(real(123.0)) << ' ' << sqrt(real(81.0)) << endl;
    cout << ceil(real(5.5)) << ' ' << floor(real(5.5)) << ' '  << floor(real(5.0)) << endl;
    cout << ceil(real(-5.5)) << ' ' << floor(real(-5.5))  << ' '  << floor(real(-5.0)) << endl;
    cout << fabs(real(50.75)) << ' ' << fabs(real(-50.75)) << endl;
    cout << fmod(real(49.5),real(4.625)) << ' ';
    
    real rd=modf(real(123.456001),0); 
    
    real ri;
    modf(real(123.456001),&ri);
    
    cout << ri << ' ' << rd << endl;

    cout << endl;
    cout << "  a  :" << a << endl;
    cout << "++a  :" << ++a  << endl;
    cout << "  a  :" <<   a  << endl;
    cout << "--a  :" << --a  << endl;
    cout << "  a  :" <<   a  << endl; 
    cout << "  a++:" <<   a++<< endl;
    cout << "  a  :" <<   a  << endl;
    cout << "  a--:" <<   a--<< endl;
    cout << "  a  :" <<   a  << endl; 
}